Segunda entrega/Django/PetshopDjango/PetshopDjango/urls.py
from django.contrib import admin
from django.urls import path
from django.urls.conf import include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('app.urls')),
    path('accounts/', include('django.contrib.auth.urls')),
    path('', include('pwa.urls')),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

Segunda entrega/Django/PetshopDjango/app/urls.py
from django.conf.urls import url
from django.contrib import admin
from django.urls import path,re_path, include
from .views import catalogo, contacto, inicio, registro, agregar_prod, modificar_prod, eliminar_lista , eliminar_prod, producto_list
from django.contrib.auth.views import LoginView, PasswordResetView, PasswordResetDoneView, PasswordResetConfirmView, PasswordResetCompleteView
from django.urls import reverse_lazy

urlpatterns = [
    path('', inicio, name="inicio"),
    path('catalogo/', producto_list, name="catalogo"),
    path('contacto/', contacto,  name="contacto"),
    path('registro/', registro, name="registro"),
    path('agregar-producto/', agregar_prod, name="agregar"),
    path('modificar/<id>/', modificar_prod, name="modificar"),
    path('eliminar', eliminar_lista, name="eliminar"),
    path('eliminar-producto/<id>/', eliminar_prod, name="eliminar-producto"),
    path('', LoginView.as_view(template_name='index.html', success_url=reverse_lazy('adopcion:solicitud_listar')), name = 'login'),
    path('reset/password_reset', PasswordResetView.as_view(template_name='registration/password_reset_forms.html', 
    email_template_name="registration/password_reset_email.html"), name = 'password_reset'),
    path('reset/password_reset_done', PasswordResetDoneView.as_view(template_name='registration/password_reset_done.html'), 
    name = 'password_reset_done'),
    re_path(r'^reset/(?P<uidb64>[0-9A-za-z_\-]+)/(?P<token>.+)/$', PasswordResetConfirmView.as_view(template_name='registration/password_reset_confirms.html'), 
    name = 'password_reset_confirm'),
    path('reset/done',PasswordResetCompleteView.as_view(template_name='registration/password_reset_complete.html') , 
    name = 'password_reset_complete'),
    path('oauth/', include('social_django.urls', namespace='social')),
    
    

]

Segunda entrega/Django/PetshopDjango/app/models.py
from django.db import models

# Create your models here.


class Animal(models.Model):
    nombre = models.CharField(max_length=50)

    def __str__(self):
        return self.nombre


class Producto(models.Model):
    nombre = models.CharField(max_length=70)
    precio = models.IntegerField()
    descripcion = models.CharField(max_length=200)
    animal = models.ForeignKey(Animal, on_delete=models.PROTECT)
    imagen = models.ImageField(upload_to="Media/productos", null=True)

    def __str__(self):
        return self.nombre

Segunda entrega/Django/PetshopDjango/app/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from .models import Producto


class CustomUserCreationForm(UserCreationForm):
    class Meta:
        model = User
        fields = ['username', 'first_name', 'last_name',
                  'email', 'password1', 'password2']

class productoform(forms.ModelForm):

    class Meta:
        model = Producto
        fields = '__all__'

Segunda entrega/Django/PetshopDjango/PetshopDjango/views.py

from django.http import HttpResponse



Segunda entrega/Django/PetshopDjango/app/views.py
from django.forms.widgets import MediaDefiningClass
from django.http.response import Http404
from django.shortcuts import redirect, render, redirect, get_object_or_404
from .models import Producto
from .forms import CustomUserCreationForm, productoform
from django.contrib.auth import authenticate, login
from django.contrib import messages
from django.core.paginator import Paginator
from django.http import Http404
# Create your views here.


def inicio(request):
    return render(request, 'app/inicio.html')


def catalogo(request):
    # aqui tira un error pero el visual studio code lo toma igual por que no lee el objects
    productos = Producto.objects.all()
    page = request.GET.get('page', 1)
    
    try:
        paginator = Paginator(productos,12)
        productos = paginator.page(page)

    except:
        raise Http404 

    data = {
        'entity': productos,
        'paginator': paginator

    }


    return render(request, 'app/catalogo.html', data)
 

def contacto(request):
    return render(request, 'app/contacto.html')


def agregar_prod(request):

    data = {
        'form' : productoform()
    }

    if request.method == 'POST':
        formulario = productoform(data = request.POST, files = request.FILES)
        if formulario.is_valid():
            formulario.save()
            messages.success(request, "Producto Registrado correctamente")
        else:
            data["form"] = formulario

    return render(request, 'producto/agregar.html', data)

def modificar_prod(request, id):

    producto = get_object_or_404(Producto, id=id)

    data = {
        'form' : productoform(instance=producto)
    }

    if request.method == 'POST':
        formulario = productoform(data=request.POST, instance=producto, files=request.FILES)
        if formulario.is_valid():
            formulario.save()
            messages.success(request, "Lo lograste putitia")
            return redirect(to="catalogo")
        data["form"] = formulario

    return render(request, 'Producto/modificar.html', data)


def registro(request):
    data = {
        'form': CustomUserCreationForm()
    }

    if request.method == 'POST':
        formulario = CustomUserCreationForm(data=request.POST)
        if formulario.is_valid():
            formulario.save()
            # estas dos lineas sirver para poder logearse automaticamente despues de registrarse
            # user = authenticate(username=formulario.cleaned_data("username"), password=formulario.cleaned_data("password1"))
            # login(request, user)
            messages.success(request, "Te has registrado correctamente")
            return redirect(to="inicio")
        data["form"] = formulario

    return render(request, 'registration/registro.html', data)

def eliminar_lista (request):

    lista = Producto.objects.all()

    data = {
        'productos' : lista
    }

    return render(request, 'Producto/eliminar.html', data)

def eliminar_prod (request, id):

    producto = get_object_or_404(Producto, id=id)
    producto.delete()
    return redirect(to="catalogo")


def producto_list(request):
    qs = Producto.objects.all()
    page = request.GET.get('page', 1)
    id_exact_query = request.GET.get('id_exact')
    nombre_query = request.GET.get('nombre')
    precio_query = request.GET.get('precio')
    

    if id_exact_query != '' and id_exact_query is not None:
        qs = qs.filter(id=id_exact_query)

    elif nombre_query != '' and nombre_query is not None:
        qs = qs.filter(nombre__icontains=nombre_query)

    elif precio_query != '' and precio_query is not None:
        qs = qs.filter(precio__icontains=precio_query)

    try:
        paginator = Paginator(qs,12)
        qs = paginator.page(page)

    except:
        raise Http404 

    context = {

        'entity': qs,
        'paginator': paginator,
        'queryset': qs
    }

    return render(request, "app/catalogo.html", context)

Segunda entrega/Django/PetshopDjango/app/templates/Producto/agregar.html
{% extends 'app/base.html' %}

{% load static %}

{% block contenido %}

{% load crispy_forms_tags %}

<link rel="stylesheet" href="{% static 'app/CSS/estilo agregar.css' %}">

<br>

<div class="container">

    </div>

    <div class="producto">

        <div class="col-12 col-md-6 offset-md-3">

            <div class="card">

                <div class="card-body">

                    <h2>Agregar Productos</h2>

                    <form action="" method="post" enctype="multipart/form-data">

                        {% csrf_token %}

                        {{ form | crispy }}  
                        
                        <input  type="submit" value="Registrar" class="btn btn-primary">

                        <a href="{% url 'catalogo' %}" class="btn btn-secondary">Volver</a>

                    </form>

                </div>
            </div>
            <br>

        </div>
    </div>  

    <div class="imagen">

        <img class="aquiles" src="{% static 'app/img/perritos.png' %}" alt="">

    </div>

    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@10"></script>

    {% if messages %}
            {% for m in messages %}
                <script>

                    Swal.fire({

                        "tittle:": "Felicitaciones",
                        "text": "{{m}}",
                        "icon": "success"
                    })

                </script>
            {% endfor %}
        {% endif %}

{% endblock %}

Segunda entrega/Django/PetshopDjango/app/templates/Producto/eliminar.html
{% extends 'app/base.html' %}

{% load static %}

{% block contenido %}

{% load crispy_forms_tags %}

<link rel="stylesheet" href="{% static 'app/CSS/estilo eliminar.css' %}">

<img class="img1" src="{% static 'app/img/michi.png' %}" alt="">

<br>

<table class="table table-striped table-over table-reponsive-sm">

    <tr>
        <td>Nombre</td>
        <td>Precio</td>
        <td>Descripcion</td>
    </tr>

    {% load humanize %}

    {% for p in productos %}

    <tr>
        <td>{{ p.nombre | title }}</td>
        <td>{{ p.precio | intcomma }}</td>
        <td>{{ p.descripcion | title }}</td>

        <td>
            <a href="{% url 'eliminar-producto' p.id %}" class="btn btn-danger"> Eliminar </a>
        </td>
       
        
    </tr>

    {% endfor %}

</table>

<img class="img2" src="{% static 'app/img/hamster.png' %}" alt="">

    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@10"></script>

    {% if messages %}
            {% for m in messages %}
                <script>

                    Swal.fire({

                        "tittle:": "Felicitaciones",
                        "text": "{{m}}",
                        "icon": "success"
                    })

                </script>
            {% endfor %}
        {% endif %}

{% endblock %}

Segunda entrega/Django/PetshopDjango/app/templates/Producto/modificar.html
{% extends 'app/base.html' %}

{% load static %}

{% block contenido %}

{% load crispy_forms_tags %}

<link rel="stylesheet" href="{% static 'app/CSS/estilo agregar.css' %}">

<br>

<div class="container">

    </div>

    <div class="producto">

        <div class="col-12 col-md-6 offset-md-3">

            <div class="card">

                <div class="card-body">

                    <h2>Modificar Productos</h2>

                    <form action="" method="post" enctype="multipart/form-data">

                        {% csrf_token %}

                        {{ form | crispy }}  

                        <div>
                        
                            <input  type="submit" value="Modificar" class="btn btn-primary">

                            <a href="{% url 'catalogo' %}" class="btn btn-secondary">Volver</a>

                        </div>

                    </form>

                </div>
            </div>
            <br>

        </div>
    </div>  

    <div class="imagen">

        <img class="aquiles" src="{% static 'app/img/perritos.png' %}" alt="">

    </div>

    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@10"></script>

    {% if messages %}
            {% for m in messages %}
                <script>

                    Swal.fire({

                        "tittle:": "Felicitaciones",
                        "text": "{{m}}",
                        "icon": "success"
                    })

                </script>
            {% endfor %}
        {% endif %}

{% endblock %}

Segunda entrega/Django/PetshopDjango/app/templates/app/base.html
<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="CSS/font-awesome.css">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
        integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" crossorigin="anonymous">
    <title>PetShop</title>

    {% load pwa %}

    {% progressive_web_app_meta %}
        
        
    {% load static %}
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.1/css/all.css"
     integrity="sha384-50oBUHEmvpQ+1lW4y57PTFmhCaXp0ML5d60M1M7uH2+nqUivzIebhndOJK28anvf" crossorigin="anonymous">
    <link rel="stylesheet" href="{% static 'app/CSS/estilos index.css' %}">
    
</head>

<body>

    <div class="contenedor">

        <div class="barra-sup">

            <a href="{% url 'inicio' %}">
                <img class="logo" src="{% static 'app/img/logo.png' %}"  alt="logo">
            </a>

            <ul class="menu">
                <li>
                    <a href="{% url 'catalogo' %}">Catalogo</a>
                </li>

                <li>
                    <a href="{% url 'contacto' %}"> Preguntas frecuentes </a>
                </li>

                {% if user.is_authenticated %}

                <li>
                    <a href="#">Bienvenido @{{ user.username }}! |</a>
                    <a href="{% url 'logout' %}">Cerrar sesión</a>
                    
                </li>

                {% else %}
                <li>
                    <a href="{% url 'login' %}">Iniciar Sesión</a>
                </li>

                <li>
                    <a href="{% url 'registro' %}">Registrarse</a>
                </li>

                {% endif %}

        </div>

    
            {% block contenido %}
                
            {% endblock %}
            

        <footer class="footer">
            <a href="https://www.facebook.com">
                <i class="fab fa-facebook-square" aria-hidden="true"></i></a>
            <a href="https://www.instagram.com">
                <i class="fab fa-instagram" aria-hidden="true"></i>
            </a>

            <a href="https://twitter.com/?lang=es"> <i class="fab fa-twitter" aria-hidden="true"></i></a>

            
        </footer>


    </div>

</body>

</html>

Segunda entrega/Django/PetshopDjango/app/templates/app/catalogo.html
{% extends 'app/base.html' %}

{% load static %}

{% block contenido %}

    <link rel="stylesheet" href="{% static 'app/CSS/estilo catalogo.css' %}">
 <div class="titulo">

     <h1 align="center">Catalogo</h1>

    <div class="d-flex justify-content-ini">

        <form action="" method="GET" >
            Filtrar por:
            <input type="search" name="nombre" placeholder="Nombre..." />
            <input type="search" name="precio" placeholder="Precio..." />
            <button type="submit" class="btn btn-primary">Buscar</button> {% csrf_token %}
        </form>

    </div>

    <div id="boton-agreg" class="d-flex justify-content-ini">

        {% if perms.app.add_producto %}

        <a href="{% url 'agregar' %}" class="d-flex justify-content-ini btn btn-primary">Agregar productos</a>

        {% endif %}


        {% if perms.app.delete_producto %}
        <a href="{% url 'eliminar' %}" class="btn btn-danger" >Eliminar productos</a>
        {% endif %}
    </div>

</div>

<div class="catalogo">
  

    {% load humanize %}

    
    {% for p in queryset%}

    <div class="img">

        {% if p.imagen %}
        <img class="img" src="{{ p.imagen.url }}" alt="comida de hamster">
        {% endif %}

        <p> {{ p.nombre | capfirst }} {{ p.descripcion | title }} <br> ${{ p.precio | intcomma}}</p>
        
        {% if perms.app.change_producto %}
        <a href="{% url 'modificar' p.id %}">Editar</a>
        {% endif %}
    </div>

    {% endfor %}

    
</div>

    <div class="paginador">
        <hr>
        {% include 'app/paginator.html' %}

    </div>

{% endblock %}

Segunda entrega/Django/PetshopDjango/app/templates/app/contacto.html
{% extends 'app/base.html' %}

{% load static %}

{% block contenido %}

<link rel="stylesheet" href="{% static 'app/CSS/estilo contactanos.css' %}">

    <div class="preguntas">

        <h2>Preguntas frecuentes</h2>

        <div class="preg">
            <ul>
                <li>
                    <p><a name="duda1" class="btn btn-secondary" onclick='mostrar1()' ondblclick='ocultar()'
                            href="#duda1" role="button">¿disponen de envio a domicilio? &raquo;</a>
                    </p>
                </li>
                <div id="resp1" class="resp" style="display: none;">
                    <p>La disponibilidad a domicilio en nustra tienda se encuentra disponible pero hasta ciertas
                        zonas de nuestro alrededores tales como santiago, valparaiso , quillota, casablanca
                </div>

                <li>
                    <p><a name="duda2" class="btn btn-secondary" onclick='mostrar2()' ondblclick='ocultar()'
                            href="#duda2" role="button">¿Hora de atencion? &raquo;</a>
                    </p>
                </li>
                <div id="resp2" class="resp" style="display: none;">
                    <p>Los horarios de nuestro local son los siguientes <br>
                        lunes a viernes: 11:00 hasta 19:00 horas <br>
                        sabado : 11:00 hasta 15:00 horas<br>
                        domingo cerrado <br>
                        feriados y festivos : 11:00 hasta 14:00 horas</p>
                </div>

                <li>
                    <p><a name="duda3" class="btn btn-secondary" onclick='mostrar3()' ondblclick='ocultar()'
                            href="#duda3" role="button">¿Como realizo mis pedidos? &raquo;</a>
                    </p>
                </li>
                <div id="resp3" class="resp" style="display: none;">
                    <p>
                        1. Buscar productos en nuestro catalogo disponible en paginas anteriores <br>
                        2. Elegir cantidad que desea comprar <br>
                        3. elegir forma de retiro o entrega <br>
                        4. Apretar comprar para ser transferido a webpay <br>
                        5. ingresar datos y selecionar medio de pago <br>
                        6. la boleta de su pedido estara disponible para su descarga o bien sera enviada a su correo
                        electronico
                        7. esperar a que su pedido llegue a casa
                    </p>
                </div>

                <li>
                    <p><a name="duda4" class="btn btn-secondary" onclick='mostrar4()' ondblclick='ocultar()'
                            href="#duda4" role="button">¿Tienen despacho a todo el pais? &raquo;</a>
                    </p>
                </li>
                <div id="resp4" class="resp" style="display: none;">
                    <p>
                        No, nuestros envíos solo se encuentran disponibles en las siguientes localidades: <br>
                        - Santiago <br>
                        - Valparaiso <br>
                        - Quillota <br>
                        - Casablanca
                    </p>
                </div>

                <li>
                    <p><a name="duda5" class="btn btn-secondary" onclick='mostrar5()' ondblclick="ocultar()"
                            href="#duda5" role="button">¿Problemas en el envio? &raquo;</a>
                    </p>
                </li>
                <div id="resp5" class="resp" style="display: none;">
                    <p>En caso de que durante el envio del producto a su localidad haya algun problema, es de suma
                        importancia tener disponible la boleta, posteriormente comunicarse a nuestro correo
                        electronico (correo electronico) o llamar al numero telefonico para solucionar el problema.
                    </p>
                </div>
            </ul>
        </div>
    </div>

   


<script src="{% static 'app/js/js contactanos.js' %}"></script>

{% endblock %}

Segunda entrega/Django/PetshopDjango/app/templates/app/inicio.html
{% extends 'app/base.html' %}

{% load static %}

{% block contenido %}

<div class="carrusel">
    <main role="main">

        <div id="carousel1" class="carousel slide carousel-fade" data-ride="carousel">
            <div class="carousel-inner">
                <div class="carousel-item active">
                    <img src="{% static 'app/img/perro-jugando.jpg' %}" alt="">
                    </svg>
                </div>

                <div class="carousel-item">
                    <svg class="bd-placeholder-img bd-placeholder-img-lg d-block " width="1300" height="400"
                        preserveAspectRatio="xMidYMid slice" focusable="false" role="img">
                        <img src="{% static 'app/img/arena tk pet gatos .png' %}" alt="arena sanitaria de gatos">
                        <rect width="100%" height="100%" fill="#f50057"></rect><text x="45%" y="50%"
                            fill="#eceff1">
                    </svg>
                </div>
                <div class="carousel-item">
                    <svg class="bd-placeholder-img bd-placeholder-img-lg d-block " width="1300" height="400"
                        preserveAspectRatio="xMidYMid slice" focusable="false" role="img">.
                        <img src="{% static 'app/img/foto 2.jpg' %}" alt="veterinaria py pet">
                        <rect width="100%" height="100%" fill="#ff3d00">
                        </rect>
                    </svg>
                </div>
            </div>

            <!--Controles NEXT y PREV-->
            <a class="carousel-control-prev" href="#carousel1" role="button" data-slide="prev">
                <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                <span class="sr-only">Previous</span>
            </a>
            <a class="carousel-control-next" href="#carousel1" role="button" data-slide="next">
                <span class="carousel-control-next-icon" aria-hidden="true"></span>
                <span class="sr-only">Next</span>
            </a>
            <!--Controles de indicadores-->
            <ol class="carousel-indicators">
                <li data-target="#carousel1" data-slide-to="0" class="active"></li>
                <li data-target="#carousel1" data-slide-to="1"></li>
                <li data-target="#carousel1" data-slide-to="2"></li>
            </ol>

        </div>

    </main>
</div>

<div class="info3">
    <img class="imginfo" src="{% static 'app/img/veterinaria 2.png' %}" alt="logo veterinaria">

    <div class="info-vet">
        <h1>My Pet</h1>
        <p>Nosotros podemos ofrecerles servicios medico, baño o guarderia de sus mascotas. <br> Busquenos en av.
            juan
            carlo calle esta exquisito <br> O llamenos al + 56 9 1557 5982 </p>
    </div>
</div>

<div class="info1">
    <div>
        <img class="imginfo" src="{% static 'app/img/comida de perro.png' %}" alt="logo catalogo">
        <p><a class="btn btn-secondary" href="{% url 'catalogo' %}" role="button">Catalogo &raquo;</a></p>
    </div>

</div>

<div class="info2">
    <div>
        <img class="imginfo" src="{% static 'app/img/contactanos.png' %}" alt="logo contactanos">
        <p><a class="btn btn-secondary" href="{% url 'contacto' %}" role="button">Contactanos &raquo;</a></p>
    </div>
</div>

<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"
integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous">
</script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"
integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous">
</script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"
integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV" crossorigin="anonymous">
</script>

<script src="https://cdn.jsdelivr.net/npm/sweetalert2@10"></script>


        {% if messages %}
            {% for m in messages %}
                <script>

                    Swal.fire({

                        "tittle:": "Felicitaciones",
                        "text": "{{m}}",
                        "icon": "success"
                    })

                </script>
            {% endfor %}
        {% endif %}

{% endblock %}

Segunda entrega/Django/PetshopDjango/app/templates/app/paginator.html
{% if paginator.num_pages > 1%}
<div class="d-flex justify-content-center">
    <ul class="pagination">
        {% if entity.has_previous %}
            <li class="page-item d-none d-sm-block"><a class="page-link" href="?page={{ entity.previous_page_number }}#pagtable">Anterior</a></li>
        {% endif %}
        {% for page in paginator.page_range %}
            {% if forloop.last and page != entity.number and paginator.num_pages > 7 %} 
                {% if entity.next_page_number != paginator.num_pages%}
                <li class="page-item">
                    <a class="page-link" href="?page={{ entity.number | add:1}}#pagtable">...</a>
                </li>
                {% endif %}
            <li class="page-item">
                    <a class="page-link" href="?page={{paginator.num_pages}}#pagtable">{{paginator.num_pages}}</a>
            </li>
            {% endif %}
            {% if page == entity.number and page > 7 %}
            <li class="page-item">
                <a class="page-link" href="?page={{ page | add:-1 }}#pagtable">...</a>
            </li>    
            {% endif %}
            {% if page < 7 or page == entity.number %}
            <li class="page-item {% if page == entity.number %}active{% endif %}">
                <a class="page-link" href="?page={{ page }}#pagtable">{{ page }}</a>
            </li>
            {% endif %}
        {% endfor %}
        {% if entity.has_next %}
            <li class="page-item d-none d-sm-block">
                <a class="page-link" href="?page={{ entity.next_page_number }}#pagtable">Siguiente</a>
            </li>
        {% endif %}
    </ul>
</div>
<div class="d-flex justify-content-center d-sm-none">            
    {% if entity.has_previous %}
        <span class="page-item"><a  class="page-link" href="?page={{ entity.previous_page_number }}#pagtable">Anterior</a></span>
    {% endif %}
    {% if entity.has_next %}
        <span class="page-item"><a class="page-link" href="?page={{ entity.next_page_number }}#pagtable">Siguiente</a></span>
    {% endif %}
    <br>
    <br>
</div>
{% endif %}